##  $Revision: 1.9 $
##  expire.ctl - expire control file
##  Format:
##	/remember/:<keep>
##	<patterns>:<modflag>:<keep>:<default>:<purge>
##  First line gives history retention; other lines specify expiration
##  for newsgroups.  Must have a "*:A:..." line which is the default.
##	<patterns>	wildmat-style patterns for the newsgroups
##	<modflag>	Pick one of M U A -- modifies pattern to be only
##			moderated, unmoderated, or all groups
##	<keep>		Mininum number of days to keep article
##	<default>	Default number of days to keep the article
##	<purge>		Flush article after this many days
##  <keep>, <default>, and <purge> can be floating-point numbers or the
##  word "never."  Times are based on when received unless -p is used;
##  see expire.8

##  If article expires before 14 days, we still remember it for 14 days in
##  case we get offered it again.  Depending on what you use for the innd
##  -c flag and how paranoid you are about old news, you might want to
##  make this 28, 30, etc.
/remember/:7

## The following is a little tricky. First we set all groups
## to expire immediately. Then, moderated groups are set to 
## 30 days, since they are usually low volume and high signal/noise.
## Finally, all unmoderated are set to expire in 7 days. Thus, only
## the groups which are not matched as either moderated or unmoderated
## are removed immediately. This allows removed groups to be expired quickly.
*:A:0:0:0
*:U:1:1:1
*:M:2:14:30
#
# big 8 newsgroups
#
news.*:U:2:3:7
comp.*:U:2:3:7
sci.*:U:2:3:7
rec.*:U:1:1:2
alt.*:U:1:1:2
#
# keep very long
#
comp.*:M:2:30:never
news.*:M:2:30:never
sci.*:M:2:30:never
linux.*:M:2:30:never
gnu.*:A:2:30:never
#
# expire noisy groups quickly
#
alt.nocem.misc,news.lists.filters:A:0.5:0.5:0.5
*offered,*jobs,*contract:U:0.5:0.5:0.5
control.cancel:A:0.1:0.1:0.1
*binaries*,*crack*,*sex*:U:0.1:0.1:0.1
alt.mag*,alt.hackintosh:U:0.1:0.1:0.1
*.test:A:1:1:2
junk:A:0:0:0
#
# local newsgroups
#
kigam.*:A:2:60:never
han.*:A:1:60:never
han.news.stats:A:1:14:never
han.binaries.*:A:1:7:14
han.test:A:1:2:3
